﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;
using System.Data.OleDb;
using Infragistics.Web.UI.GridControls;

namespace HierarchicalGrid
{
    public partial class Default4 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                // Set up connection and command to retrieve the Customers table
                OleDbConnection con = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "Nwind.mdb");
                //retrieve all customers (including country data for each customer)
                OleDbCommand comCustomers = new OleDbCommand("select CustomerID, ContactName, ContactTitle, Address, City, Region, Country, Phone from Customers", con);
                
                // Set up a data adapter to fill up a dataset with data from the query
                OleDbDataAdapter daCustomers = new OleDbDataAdapter(comCustomers);
                DataSet countryCustomersDataSet = new DataSet();

                con.Open();

                // Retrieve data from the database into the customers table
                daCustomers.Fill(countryCustomersDataSet, "Customers");

                con.Close();

                //create a dataview of the customers table, sorted by country name
                DataView dv = countryCustomersDataSet.Tables["Customers"].DefaultView;
                dv.Sort = "Country ASC";
                //add a new table called "Countries" with the distinct Country column values from the Customers table
                countryCustomersDataSet.Tables.Add(dv.ToTable("Countries", true, "Country"));

                //Set up a data relation for the Customers table with the Countries table
                //using the country column values to match records in a parent-child relationship
                DataRelation rel = new DataRelation("CountryCustomers",
                    countryCustomersDataSet.Tables["Countries"].Columns["Country"],
                    countryCustomersDataSet.Tables["Customers"].Columns["Country"]);
                countryCustomersDataSet.Relations.Add(rel);

                // Set the table's primary key field
                countryCustomersDataSet.Tables["Countries"].PrimaryKey = new DataColumn[] { 
                    countryCustomersDataSet.Tables["Countries"].Columns["Country"] };

                // Store the data in Session state
                this.Session["CountryCustomers"] = countryCustomersDataSet;
            }

            // Retrieve data from Session state
            DataSet ds = this.Session["CountryCustomers"] as DataSet;
            // Set up data source and bind to grid
            this.WebHierarchicalDataGrid1.DataSource = ds;

            this.WebHierarchicalDataGrid1.DataMember = "Countries";
            this.WebHierarchicalDataGrid1.DataKeyFields = "Country";
            this.WebHierarchicalDataGrid1.DataBind();
        }

        protected void WebHierarchicalDataGrid1_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
        {
            ((ContainerGridRecord)e.Row).Expanded = true;
        }
    }
}
